﻿<template>
    <div class="content-grid content-grid--subpage content-grid--subpage-table">
        <Breadcrumbs :title="t(`routes.admin.children.members.name`)" />
        <div class="content-grid__header">
            <h1 class="back-link-title">{{ t(`routes.admin.children.members.name`) }}</h1>
            <div class="content-grid__filters">
                <SearchInput v-model="searchValue" />
            </div>
        </div>
        <Card :title="t('global.quickLinks')" class="card--row-content">
            <BtnLink :name="t('routes.admin.children.members.add.name')"
                     :path="{ name: 'admin.children.members.add' }" />
        </Card>
        <Card>
            <DataTable :headers="memberHeader"
                       :is-loading="membersAreLoading"
                       :items="tableMembers"
                       :search-value="searchValue"
                       @delete="deleteMember" />
        </Card>
    </div>
</template>

<script lang="ts" setup>
    import { useI18n } from "vue3-i18n";
    import { computed, onMounted, ref } from "vue";
    import { useMemberService } from "@/inversify.config";
    import { notifyError, notifySuccess } from "@/notify";
    import Card from "@/components/layout/Card.vue";
    import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import SearchInput from "@/components/layout/SearchInput.vue";
    import DataTable from "@/components/layout/DataTable.vue";
    import BtnLink from "@/components/layout/BtnLink.vue";
    import { Member } from "@/types/entities";

    const { t } = useI18n()
    const memberService = useMemberService()

    const allMembers = ref<Member[]>([]);
    const searchValue = ref("");
    const membersAreLoading = ref(false);

    const tableMembers = computed(() => {
        return allMembers.value.map((x: Member) => {
            return {
                id: x.id,
                firstName: x.firstName,
                lastName: x.lastName,
                email: x.email,
                actions: {
                    update: { name: `admin.children.members.edit`, params: { id: x.id } },
                    delete: true
                }
            }
        }).sort((a: any, b: any) => {
            if (a.lastName < b.lastName) {
                return -1;
            }
            if (a.lastName > b.lastName) {
                return 1;
            }
            return 0;
        }) as Member[];
    })

    onMounted(async () => {
        await loadAllMembers();
    });

    async function loadAllMembers() {
        membersAreLoading.value = true;

        let members = await memberService.getAllNonAdmin();
        if (members && members.length > 0) {
            allMembers.value = members;
        }
        membersAreLoading.value = false;
    }

    async function deleteMember(member: any) {
        if (member?.id == null) {
            return;
        }

      let confirmDelete = confirm(t("validation.member.delete.confirmation"));
      if (!confirmDelete) {return}

      let response = await memberService.deleteMember(member.id)
      if (response.succeeded) {
          allMembers.value = await memberService.getAllNonAdmin()
          notifySuccess(t('validation.member.delete.deactivate'))
      } else {
        let errorMessages = response.getErrorMessages('validation.member.delete',
            'validation.member.delete.errorOccured')
        notifyError(errorMessages[0])
      }
    }

    const memberHeader = [
        {
            text: t("member.form.lastName"),
            value: 'lastName',
            sortable: true,
            width: 50,
        },
        {
            text: t("member.form.firstName"),
            value: "firstName",
            sortable: true,
            width: 50,
        },
        {
            text: t("member.form.email"),
            value: "email",
            sortable: true,
            width: 50,
        },
        {
            text: t("global.table.actions"),
            value: "actions",
            width: 1
        },
    ];

</script>
